export const PRESALE_BEGIN = 'presale_begin'

export const PRESALE_ORDER_GET = 'presale_order_get'

export const PRESALE_SUCCESS = 'presale_success'

export const PRESALE_ERROR = 'presale_error'

export const NEED_LOGIN = 'need_login'

export const NEED_NONCE = 'need_nonce'

export const ACCOUNT_CHANGE = 'account_change'

export const SHOW_CHAIN_MODAL = 'show_chain_modal'

export const NEED_CHANGE_CHAIN = 'need_change_chain'

export const WALLET_SELECTED = 'wallet_selected'

export const CHAIN_SELECTED = 'chain_selected'

export const SHOW_ERR_MSG = 'show_err_msg'

let createNanoEvents = () => ({
  events: {},
  $emit(event, ...args) {
    for (let i of this.events[event] || []) {
      i(...args)
    }
  },
  $on(event, cb) {
    ;(this.events[event] = this.events[event] || []).push(cb)
    return () =>
      (this.events[event] = this.events[event].filter((i) => i !== cb))
  },
  $off(event, cb) {
    this.events[event] = this.events[event].filter((i) => i !== cb)
  },
  listen(event, cb) {
    ;(this.events[event] = this.events[event] || []).push(cb)
    return () =>
      (this.events[event] = this.events[event].filter((i) => i !== cb))
  },
})

let eventBus
if (!eventBus) {
  eventBus = createNanoEvents()
}

export const EventBus = eventBus
